#include <conio.h>
#include <io.h>
#include <fcntl.h>
#include <malloc.h>
#include <process.h>
#include <dos.h>
#include <stdio.h>
#include <dos.h>

typedef unsigned int word;
typedef unsigned char byte;
typedef struct {char name[0x13];
		byte kenn;
		byte ofst[2];
		word ver;
		word comp;} VOCHEADER;
typedef struct {byte type;
		byte size[3];} VOCDATABLOCK;

typedef unsigned int handle;
typedef struct {unsigned long l;
		unsigned int hq;
		void far *oq;
		unsigned int hz;
		void far *oz;}cpy;

/*LIBRARY XMS.LIB INCLUDIERT, DA XMS VERWENDET WIRD!*/

void far (*himem)(void);

void _initxms()
{
 unsigned sg,of;

 asm{MOV AX,0x4300
     INT 0x2f
     CMP AL,0x80
     JNZ error
     MOV AX,0x4310
     INT 0x2f
     MOV of,BX
     MOV AX,ES
     MOV sg,AX
     JMP noerror};
 error:
     clrscr();
     printf("No himem.sys installed!\n\n");
     abort();
 noerror:
     himem=MK_FP(sg,of);
}

unsigned int _xmsver()
{
 unsigned int ver;
 asm{MOV AX,0x0000};
 himem();
 asm{MOV ver,AX};
 return ver;
}

unsigned int _opena20()
{
 asm {MOV AH,0x03};
 himem();
 return _AX;
}

unsigned int _closea20()
{
 asm{MOV AH,0x04};
 himem();
 return _AX;
}

unsigned int _xmsfree()
{
 asm{MOV AH,0x08};
 himem();
 return _AX;
}

unsigned int _allocxms(unsigned int size,handle *h)
{
 asm{MOV AH,0x09
     MOV DX,size};
 himem();
 *h=_DX;
 return _AX;
}

unsigned int _freexms(handle *h)
{
 unsigned int hd;
 hd=*h;
 asm{MOV AH,0x0a
     MOV DX,hd};
 himem();
 return _AX;
}

unsigned int _mem2xms(char far *memo, unsigned long lengh, handle *hd)
{
 cpy stc;

 stc.l=lengh;
 stc.hq=0;
 stc.oq=memo;
 stc.hz=*hd;
 stc.oz=0;
 _CX=&stc;
 _DX=_DS;
 asm{PUSH DS
     MOV DS,DX
     MOV SI,CX
     MOV AH,0x0b};
 himem();
 asm{POP DS};
 return _AX;
}

unsigned int _xms2mem(char far *memo, unsigned long lengh, handle *hd)
{
 cpy stc;

 stc.l=lengh;
 stc.hq=*hd;
 stc.oq=0;
 stc.hz=0;
 stc.oz=memo;
 _CX=&stc;
 _DX=_DS;

 asm{PUSH DS
     MOV DS,DX
     MOV SI,CX
     MOV AH,0x0b};
 himem();
 asm{POP DS};
 return _AX;
}

//**************************************************************************

 void interrupt (*oldirq)();

 byte error;                             //allgem. Fehlerflag
 long lengh;                             //Lnge des aktuellen VOC-Files
 long left;                              //Noch zu verbleibende Bytes
 char far *dmabuffer;                    //DMA-BUFFER=32k
 char far *dmabuffer2;                   //2. DMA-Buffer
 byte dmaready,flg;                      //Spielen schon fertig?
 byte anzxms;                            //Anz. der verw. XMS-Blcke
 byte blocks2play;                       //Wieviele Blcke zu spielen?
 handle vocdata[64];                     //Daten im XMS
 word vocl[64];                          //wieviel / Block?
 byte page,sample,compression,timeconst; //konst. Werte des Files
 word offset;                            //
 //FILE *VOC;                              //Voc-File
 VOCHEADER header;                       //Header
 VOCDATABLOCK databl;                    //und Datenblock dauerhaft speichern


byte readdsp()
{
 do
 {
  asm NOP;
 } while ((inportb(0x22e)&128)==0);
 return inportb(0x22a);
}

int resetdsp()
{
 word a=0;
 outportb(0x0226,1);
 delay(6);
 outportb(0x0226,0);
 do
 {
  asm NOP;
 }
 while ((inportb(0x022e)&128)==0);
 do
 {
  a++;
  delay(1);
 }
 while (inportb(0x22a)!=0xaa && a<10);
 if (a>9) return -1;
 else return 0;
}

void writedsp(byte val)
{
 do
 {
  asm NOP;
 }
 while ((inportb(0x22c)&128)==128);
 outportb(0x22c,val);
}

void convpage(byte far *mem, byte *page, word *ofset)
{
 word a,b;

 a=FP_SEG(mem);
 b=FP_OFF(mem);

 asm{MOV DX,a
     MOV AX,b
     MOV BL,DH
     SHR BL,4
     SHL DX,4
     ADD AX,DX
     ADC BL,0
     MOV DH,BL};
 *page=_DH;
 *ofset=_AX;
}

void playblock(byte far *data, word size)
{
 convpage(data,&page,&offset);
 outportb(0x0a,0x05);
 outportb(0x0c,0);
 outportb(0x0b,0x49);
 outportb(0x02,offset&255);
 outportb(0x02,offset>>8);
 outportb(0x83,page);
 outportb(0x03,size&255);
 outportb(0x03,size>>8);
 writedsp(0x40);
 writedsp(sample);              //bertragungsfrequenz
 writedsp(0x14);
 writedsp(size&255);
 writedsp(size>>8);
 outportb(0x0a,1);
 writedsp(0xd1);
}

void contplay(byte far* data,word size)
{
 convpage(data,&page,&offset);
 outportb(0x0a,0x05);
 outportb(0x0c,0);
 outportb(0x0b,0x49);
 outportb(0x02,offset&255);
 outportb(0x02,offset>>8);
 outportb(0x83,page);
 //outportb(0x03,size&255);
 //outportb(0x03,size>>8);
 writedsp(0x40);
 writedsp(sample);              //bertragungsfrequenz
 writedsp(0x14);
 writedsp((size-2)&255);
 writedsp((size-2)>>8);
 outportb(0x0a,1);
 //writedsp(0xd1);
}


unsigned long lengh_file (char *filename)
{
 unsigned long l;
 handle h;

 h=open(filename,O_RDONLY);
 l=filelength(h);
 close (h);
 return l;
}

void interrupt dmairq()
{
 if ((blocks2play&1)==0)
 {
  contplay(dmabuffer,vocl[blocks2play]);
 }
 else
  contplay(dmabuffer2,vocl[blocks2play]);

 blocks2play++;
 if (blocks2play<=anzxms)
 {
  inportb(0x22e);
  outportb(0x20,0x20);
  dmaready=0;
 }
 else
 {
  dmaready=1;
  writedsp(0xd3);
 }
}

int playmax64(char *filename, word cut)
{
 byte *datas;
 FILE *VOC;
 register int i;

 if (lengh_file(filename)>65000) return -2;
 if (resetdsp()==-1) return -255;
 VOC=fopen(filename,"rb");                         //File ffnen
 fread (&header,sizeof(VOCHEADER),1,VOC);          //Header lesen
 fseek (VOC,header.ofst[1]*256+header.ofst[0],0);  //DatenBlock positionieren
 fread (&databl,sizeof(VOCDATABLOCK),1,VOC);       //DatenBlock lesen
 lengh=databl.size[0]+(word)databl.size[1]*256+(long)databl.size[2]*65536;
 sample=getc(VOC);
 compression=getc(VOC);
 timeconst=256-((long)100000/(long)sample);
 datas=(char *)malloc(lengh+20);  //Speicher reservieren!
 if (datas==NULL) return -1;
 fread(datas,1,(lengh+2),VOC);      //Daten einlesen
 playblock(datas,(lengh&0xffff)-cut);
 fclose(VOC);
 free(datas);
 return 0;
}

int playvoc(char *filename, word cut)
{
 FILE *VOC;
 long laenge;
 byte datas[32020];
 register int i;

 //laenge=lengh_file(filename);
 if (resetdsp()==-1) return -255;
 /*if (laenge<60000)
 {
  playmax64(filename,cut);
  return 0;
 }*/
 dmabuffer=(char far*)farmalloc(64030);
 if (dmabuffer==NULL) return -5;

 dmabuffer2=dmabuffer+32000;

 VOC=fopen(filename,"rb");                         //File ffnen
 fread (&header,sizeof(VOCHEADER),1,VOC);          //Header lesen
 fseek (VOC,header.ofst[1]*256+header.ofst[0],0);  //DatenBlock positionieren
 fread (&databl,sizeof(VOCDATABLOCK),1,VOC);       //DatenBlock lesen
 lengh=databl.size[0]+(word)databl.size[1]*256+(long)databl.size[2]*65536;
 lengh-=(long)cut;
 sample=getc(VOC);
 compression=getc(VOC);
 timeconst=256-((long)100000/(long)sample);
 _initxms();
 _opena20();
 if (_xmsfree()<=(lengh/1024)+32) return -3;

 anzxms=0;
 do
 {
  vocl[anzxms]=32000;
  fread(datas,1,32000,VOC);      //Daten einlesen
  _allocxms(32,&(vocdata[anzxms]));
  _mem2xms (datas,32000,&(vocdata[anzxms]));
  anzxms++;
 }while (anzxms-1<lengh/32000);

 blocks2play=0;
 vocl[anzxms-1]=(int)(lengh%32000);
 fclose(VOC);
 outportb(0x21,inportb(0x21)&127);
 oldirq=getvect(0x0f);
 setvect(0x0f,dmairq);
 outportb(0x20,0x20);
 _xms2mem (dmabuffer,32000,&(vocdata[blocks2play]));
 //_xms2mem (dmabuffer2,32000,&(vocdata[blocks2play+1]));
 playblock(dmabuffer,vocl[blocks2play]);
 blocks2play++;
 dmaready=0;
 error=0;
 return 0;
}

void stopvoc()
{
 register int i;
 if (error==0)
 {
  for (i=0; i<anzxms; i++)
   _freexms(&(vocdata[i]));
  _closea20(); //*/
  setvect (0x0f,oldirq);
  outportb(0x20,0x20);
  farfree (dmabuffer);
 }
}

int nextblock()
{
 asm CLI;
 if (flg!=blocks2play)
 {
  if ((blocks2play&1)==1)
   _xms2mem (dmabuffer2,32000,&(vocdata[blocks2play]));
  else
   _xms2mem (dmabuffer,32000,&(vocdata[blocks2play]));
 }
 flg=blocks2play;
 if (dmaready==1) writedsp(0xd3);
 asm STI;
 return dmaready;
}
